package com.company.jmix.test.screen.alert;

import com.company.jmix.test.entity.Alert;
import com.company.jmix.test.entity.AlertModel;
import com.company.jmix.test.entity.Model;
import io.jmix.core.DataManager;
import io.jmix.ui.model.CollectionContainer;
import io.jmix.ui.screen.*;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;

@UiController("jt_Alert.create")
@UiDescriptor("alert-create.xml")
@EditedEntityContainer("alertDc")
public class AlertCreate extends StandardEditor<Alert> {
    @Autowired
    private DataManager dataManager;
    @Autowired
    private CollectionContainer<AlertModel> alertModelsDc;

    @Subscribe
    public void onAfterShow(final AfterShowEvent event) {
        initAlertModelsDc();
    }

    private void initAlertModelsDc() {
        List<Model> allModels = dataManager.load(Model.class).all().list();
        List<AlertModel> alertModels = allModels.stream().map(model -> {
            AlertModel alertModel = dataManager.create(AlertModel.class);
            alertModel.setAlert(getEditedEntity());
            alertModel.setModel(model);
            return alertModel;
        }).toList();
        alertModelsDc.setItems(alertModels);
    }

    @Subscribe
    public void onBeforeCommitChanges(final BeforeCommitChangesEvent event) {
        List<AlertModel> alertModelsToCommit = alertModelsDc.getItems().stream().filter(AlertModel::getIsInAlert).toList();
        event.getDataContext().merge(alertModelsToCommit);
    }


}